//  ..  2005.
// a_biv @ list . ru    
#include <pic18.h>
////////////////////////////////////////////////////////////
__CONFIG(1, HSPLL); // HSPLL
__CONFIG(2, PWRTEN & BORV20 & BOREN & WDTDIS & WDTPS128);
__CONFIG(4, DEBUGDIS & LVPDIS & STVREN);
__CONFIG(5, UNPROTECT);
__CONFIG(6, WPU);
__CONFIG(7, PTBRU);
////////////////////////////////////////////////////////////
#define	FOSC			(40000000L) //   
#define baud			19200		// define USART baud rate
#define i2c_bus_rate	(400000L)	// define I2C bus rate
#define Wait_I2C		while(SSPIF == 0){} SSPIF = 0; //     I2C
///////////    /////////////////////
bit						WR_Adc		@ (unsigned)&PORTC*8+0 ; // WR 
bit						Res_Lcd		@ (unsigned)&PORTC*8+5 ; // RESET LCD
bit						Vok_A		@ (unsigned)&PORTA*8+4 ; // 
bit						Vok_B		@ (unsigned)&PORTA*8+5 ; // 
//////////   
static unsigned char	Over_TMR1	@ 0x100; //   TMR1.
bit						Flash		@ (unsigned)&Over_TMR1*8+1 ; //   .
static unsigned char	BufADC[101];    //  
unsigned char			Count_ADC;      //  
unsigned char			Count_TMR1;     //  
unsigned char			Y_Offset;       //   
bit						Vok_Tmp;        //  
////////////   /////////////////////////
void DelayUs(unsigned char dcnt){
	while(--dcnt > 0) {
		asm("nop");
		asm("nop");
		asm("nop");
		asm("nop");
		asm("nop");
		asm("nop");
		asm("nop");
	}
} 	
/////////////////   ////////////////////////
void DelayMs(unsigned char cnt){
	unsigned char i;
	while (cnt--) {
		i=4;
		while(i--) {
			DelayUs(246);	/* Adjust for error */
		}
	}
}
/////////////////   ////////////////////////
void LCD_Init(void) {
	unsigned int m = 0;
	DelayMs(230); // 230 mS
	Res_Lcd = 1; //  
	SSPIF = 0;
	SEN = 1; Wait_I2C; // "START"  I2C
	SSPBUF = 0x7A; Wait_I2C;        //   
	SSPBUF = 0x00; Wait_I2C;        // Co = 0, D/C = 0
	SSPBUF = 0x21; Wait_I2C;        // H=1 mode
	SSPBUF = 0x0F; Wait_I2C;        // DO=1; TRS=1; BRS=1; 
	SSPBUF = 0x10 | 5; Wait_I2C;  // bias 0-7
	SSPBUF = 0x80 | 106; Wait_I2C; // Vop 0-127
	SSPBUF = 0b00100010; Wait_I2C; // MX=0; MY=0; PD=0; V=1; H=0;
	SSPBUF = 0b00001100; Wait_I2C; // DO=1; TRS=1; BRS=1; normal mode
	RSEN = 1; Wait_I2C; // "RESTART"  I2C
	SSPBUF = 0x7A; Wait_I2C; //   
	SSPBUF = 0x40 | 0; Wait_I2C; //   Y 0-6 
	SSPBUF = 0x80 | 0; Wait_I2C; //  X - 0-101
		for(m = 0; m < 918; m++){ // 102x8 
		SSPBUF = 0x00; Wait_I2C; // 
	}
	PEN = 1; Wait_I2C; // "STOP"  I2C
}
/////////////////    LCD ////////////////////////
void LCD_Write(void) { // 0-100 - 0-53
	unsigned char BAdr, Temp, Temp2;
	SEN = 1; Wait_I2C; // "START"  I2C
	SSPBUF = 0x7A; Wait_I2C; //   
	SSPBUF = 0x00; Wait_I2C; //   
	SSPBUF = 0x40; Wait_I2C; //   Y 0-6 
	SSPBUF = 0x80; Wait_I2C; //  X - 0-101
	RSEN = 1; Wait_I2C; // "RESTART"  I2C
	SSPBUF = 0x7A; Wait_I2C; //   
	SSPBUF = 0x40; Wait_I2C; //      
	for (BAdr = 0; BAdr < 101; BAdr++){
		if (BufADC[BAdr] <= Y_Offset){
			Temp2 = 0;
		}else{
			Temp2 = BufADC[BAdr] - Y_Offset;
		}
		if (Temp2 >= 53) {
			Temp2 = 0;
		}else{
			Temp2 = 53 - Temp2;
		}
		Temp = Temp2 >> 3;
		while (Temp > 0){
			SSPBUF = 0x00; Wait_I2C;
			Temp--;
		}
		SSPBUF = 0b00000001 << (Temp2 & 0b00000111); Wait_I2C;
		Temp = Temp2 >> 3;
		while (8 > Temp){
			SSPBUF = 0x00; Wait_I2C;
			Temp++;
		}
	}
	PEN = 1; Wait_I2C; // "STOP"  I2C
}
///////////   ////////////////////////////////
void KeyPress(void) {
	if (Vok_Tmp != Vok_B){
		DelayUs(250); // 
		DelayUs(250); // 
		DelayUs(250); // 
		if (Vok_B != Vok_A){
			Y_Offset++;
		}else{
			Y_Offset--;
		}
		Vok_Tmp = Vok_B;
	}
}
///////////    //////////////
void interrupt Timer_0(void) {
	WR_Adc = 1;
//	asm("nop"); asm("nop");//  //  200 nS
	BufADC[Count_ADC] = PORTB; // 
	Count_ADC++;
	if (Count_ADC >= 101) Count_ADC = 0;
	TMR0IF = 0; //  
	TMR0H = 0xFF; // 
	TMR0L = 0xF1; // 65536 - (TMR0H_TMR0L) = x, 1=10
	WR_Adc = 0; //  
}
///////////    ////////////////
void interrupt low_priority Timer_1(void) {
	KeyPress();
	if (Count_TMR1 == 40) {
		Count_TMR1 = 0;
		LCD_Write();
	}
	Count_TMR1++;
	TMR1IF = 0; //  
}
/////////////////   ////////////////////////
void main(void){
	OSCCON = 0x00; //  
	WDTCON = 0x00; //  
	LVDCON = 0b00000101; // 2.8V LVD .
	ADCON0 = 0b10000000; // ADC . Tosc/64
	ADCON1 = 0b01000111; //  ,  . 
	TRISA = 0b00110000; //  
	TRISB = 0b11111111; //  
	TRISC = 0b00011000; //  
	PORTA = PORTB = PORTC = 0x00; //  ,   
	LATA = 0b00000000;  //  ,   
	LATB = 0b00000000;  //  ,   
	LATC = 0b00000001;  //  ,   

	SSPIF = 0;            // reset I2C based interrupt flag
	SSPCON2 = 0b00000000; // ensure all state bits are reset
	SSPSTAT = 0b00000000;
	SSPADD = ( FOSC / (4 * i2c_bus_rate)) - 1; // initialize i2c bus rate
	SSPCON1 = 0b00111000;   // Master I2C mode

	SPBRG = (int)( FOSC / (16UL * baud)) - 1; // 9600 baud @ 16MHz
	TXSTA = 0b00100100;     // enable Transmitter, BRGH = 1
	RCREG;                  // dummy read
	RCSTA = 0b10010000;     // continuous receive, serial port enabled 

	T0CON = 0b10001000; // 16bit, CLKOUT, 1:1, On. 6.5mS, 152Hz.
	TMR0H = TMR0L = 0x00;
	T1CON = 0b10000001; // 16bit, CLKOUT, 1:1, On. 6.5Ms.
	TMR1H = TMR1L = 0x00;
	T2CON = 0b00000000; //
	TMR2 = 0x00; PR2 = 0x00;
	T3CON = 0b00000000; //
	TMR3H = TMR3L = 0x00;
	CCP1CON = 0b00000000;
	CCPR1H = CCPR1L = 0x00;
	CIOCON = 0x00; CANCON = 0b00100000; // CAN - Off
	PIE3 = IPR3 = PIR3 = 0x00; // CAN Interrupt - Off
	WR_Adc = 0; //   
	LCD_Init(); //  .
	WR_Adc = 1;	asm("nop"); asm("nop");//  // 
	asm("nop"); asm("nop"); asm("nop"); asm("nop");// 600 nS
	Y_Offset = PORTB - 26; //   
	IPEN = 1; //   .
	TMR0IP = 1; TMR0IF = 0; TMR0IE = 1; // TMR0 -  
	TMR1IP = 0; TMR1IF = 0; TMR1IE = 1; // TMR1 -  
	GIEL = GIEH = 1; //   
	for(;;){  //  	      ////////////////

		LATA0 = 1;
		DelayMs(2);
		LATA0 = 0;
		DelayMs(4);

    }  // end loopen
}
